/*
 * [VWFX`FW[
 * 
 *  Copyright (c) 2010
 *  Panasonic System Networks Co., Ltd.
 *  All rights reserved.
 *
 * EAPI`wb_t@C
 *
 */

#ifndef MW_MGR_MGR_H_
#define MW_MGR_MGR_H_

#include <nn/types.h>

/*------------------------------------------------------------------------------------*/
#define		MGRCG_BDYMAX		(    4 )			/* F̍ő吔				  */
/*------------------------------------------------------------------------------------*/
#define		MGIMG_WIDMIN		(  128 )			/* 摜ŏl				  */
#define		MGIMG_WIDMAX		(  160 )			/* 摜ől				  */
#define		MGIMG_HEIMIN		(   96 )			/* 摜ŏl				  */
#define		MGIMG_HEIMAX		(  120 )			/* 摜ől				  */
#define		MGEXT_RECTMIN		(   64 )			/* Ώۋ`̈扡ŏl */
/*------------------------------------------------------------------------------------*/
#define		MGPAR_MODEMIN		(    0 )			/* F샂[hŏl			  */
#define		MGPAR_MODEMAX		(    1 )			/* F샂[hől			  */
/*------------------------------------------------------------------------------------*/
#define		MGPAR_FRMMIN		(    0 )			/* t[ԍxŏl		  */
#define		MGPAR_FRMMAX		(   10 )			/* t[ԍxől		  */
/*------------------------------------------------------------------------------------*/
#define		MGPAR_SPDMIN		(    0 )			/* xxŏl				  */
#define		MGPAR_SPDMAX		(    4 )			/* xxől				  */
/*------------------------------------------------------------------------------------*/
#define		MGPAR_SKNMIN		(    0 )			/* F̨xŏl			  */
#define		MGPAR_SKNMAX		(  200 )			/* F̨xől			  */
/*------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------*/
#define		PSERR_TRUE			(    0 )			/* 						  */
#define		PSERR_MEMR			(   -1 )			/* s					  */
#define		PSERR_ARGU			(   -2 )			/* 						  */
#define		PSERR_IMAG			(   -3 )			/* 摜ُ						  */
#define		PSERR_PROC			(   -4 )			/* s\						  */
#define		PSERR_RECG			(   -5 )			/* Fs					  */
/*------------------------------------------------------------------------------------*/

namespace mw { namespace mgr {

typedef struct {

	u8			Z ;								/* _~[						  */
    u8			B ;								/* flΐ 				  */
    u8			G ;								/* flԐ 				  */
    u8			R ;								/* fl    				  */

} RGBColor;

typedef struct {

    s32			xSize  ;						/* 摜f[^				  */
    s32			ySize  ;						/* 摜f[^				  */
    RGBColor	*pcImg ;						/* J[摜f[^				  */

} PSCimg ;

typedef struct {

    s32			x ;								/* _xW[f]				  */
    s32			y ;								/* _yW[f]				  */

} PSPoint ;

typedef struct {

	s32			sx ;							/* `̈Jn_xW[f]  */
	s32			sy ;							/* `̈Jn_yW[f]  */
	s32			ex ;							/* `̈I_ExW[f]  */
	s32			ey ;							/* `̈I_EyW[f]  */

} PSRect ;

typedef struct {

	u32	        id     ;						/* ID						  */
    PSRect		rect   ;						/* ̋`ʒu					  */
    PSPoint		center ;						/* ̒Sʒu					  */

} MGObject ;

typedef struct {

    u32         bodynum                ;		/* ̐						  */
    MGObject	mgobject[MGRCG_BDYMAX] ;		/* 							  */
	s32         reserve0               ;		/* \0						  */
	s32			reserve1               ;		/* \1						  */
	s32			reserve2               ;		/* \2						  */
	s32			reserve3               ;		/* \3						  */

} MGResult ;

typedef struct {

	s32			xsize    ;						/* 摜f[^ (128,160)		  */
	s32			ysize    ;						/* 摜f[^ ( 96,120)		  */
    PSRect		mgrect   ; 						/* Ώۋ`̈				  */
    u8          mgmode   ;						/* F샂[h (0,1)			  */
    u8          frmparam ;						/* t[ԍx (0`10)	  */
    u8	        spdparam ;						/* xx (0,1,2,3,4)			  */
	u8          sknparam ;						/* F̨Ұ (0`200)		  */
    u8          reserve0 ;						/* \tO0					  */
	u8          reserve1 ;						/* \tO1					  */
	u8          reserve2 ;						/* \tO2					  */
	u8          reserve3 ;						/* \tO3					  */

} MGConfig ;

s32 		MGRcgGetWorkSize		( MGConfig*, u32*     ) ;
s32 		MGRcgProcessInit		( MGConfig*, u8*     ) ;
s32 		MGRcgProcessExec		( MGConfig*, PSCimg*, MGResult* ) ;


}}

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {

    s32			x ;								/* _xW[f]				  */
    s32			y ;								/* _yW[f]				  */

} mwmgrPSPoint ;

typedef struct {

	s32			sx ;							/* `̈Jn_xW[f]  */
	s32			sy ;							/* `̈Jn_yW[f]  */
	s32			ex ;							/* `̈I_ExW[f]  */
	s32			ey ;							/* `̈I_EyW[f]  */

} mwmgrPSRect ;

typedef struct {

	u8			Z ;								/* _~[						  */
    u8			B ;								/* flΐ 				  */
    u8			G ;								/* flԐ 				  */
    u8			R ;								/* fl    				  */

} mwmgrRGBColor;

typedef struct {

    s32				xSize  ;					/* 摜f[^				  */
    s32				ySize  ;					/* 摜f[^				  */
    mwmgrRGBColor	*pcImg ;					/* J[摜f[^				  */

} mwmgrPSCimg ;

typedef struct {

	u32				id     ;					/* ID						  */
    mwmgrPSRect		rect   ;					/* ̋`ʒu					  */
    mwmgrPSPoint	center ;					/* ̒Sʒu					  */

} mwmgrMGObject ;

typedef struct {

    u32				bodynum                ;	/* ̐						  */
    mwmgrMGObject	mgobject[MGRCG_BDYMAX] ;	/* 							  */
	s32				reserve0               ;	/* \0						  */
	s32				reserve1               ;	/* \1						  */
	s32				reserve2               ;	/* \2						  */
	s32				reserve3               ;	/* \3						  */

} mwmgrMGResult ;

typedef struct {

	s32				xsize    ;					/* 摜f[^ (128,160)		  */
	s32				ysize    ;					/* 摜f[^ ( 96,120)		  */
    mwmgrPSRect		mgrect   ; 					/* Ώۋ`̈				  */
    u8				mgmode   ;					/* F샂[h (0,1)			  */
    u8				frmparam ;					/* t[ԍx (0`10)		  */
    u8				spdparam ;					/* xx (0,1,2,3,4)			  */
	u8				sknparam ;					/* F̨Ұ (0`200)		  */
    u8				reserve0 ;					/* \tO0					  */
	u8				reserve1 ;					/* \tO1					  */
	u8				reserve2 ;					/* \tO2					  */
	u8				reserve3 ;					/* \tO3					  */

} mwmgrMGConfig ;

s32 	mwmgrMGRcgGetWorkSize		( mwmgrMGConfig*, u32*     ) ;
s32 	mwmgrMGRcgProcessInit		( mwmgrMGConfig*, u8*     ) ;
s32		mwmgrMGRcgProcessExec		( mwmgrMGConfig*, mwmgrPSCimg*, mwmgrMGResult* ) ;

#ifdef __cplusplus
}
#endif

#endif /* MW_MGR_MGR_H_ */

