#ifndef _CTR_DEFINE_H_
#define _CTR_DEFINE_H_

#define ENABLE_TIMESCALE 


#include "CTR_Memory.h"
#include "CTR_Fio.h"
#ifdef ENABLE_TIMESCALE 
#include "CTR_Tick.h"
#ifdef TIME_SET_USEC
#define TIME_UNIT "usec"
#else
#define TIME_UNIT "msec"
#endif /* #ifdef TIME_SET_USEC */
#endif /* #ifdef ENABLE_TIMESCALE  */

/* n */
#define OS_MEM_INIT   CTR_MEM_Init
#define OS_MEM_TERM   CTR_MEM_Term
#define OS_MALLOC_EX  CTR_MEM_MallocEx
#define OS_MALLOC32   CTR_MEM_Malloc32
#define OS_MALLOC     CTR_MEM_Malloc
#define OS_FREE       CTR_MEM_Free
#define OS_GET_FREEHEAPSIZE CTR_MEM_GetFreeSizeOfHeap
#define MEMSET        CTR_MEMSET
#define MEMSET32      CTR_MEMSET
#define MEMCPY        CTR_MEMCPY
#define MEMCPY32      CTR_MEMCPY
#define MEMCMP        CTR_MEMCMP


/* t@Cn */
#define FILE_IO_INIT        CTR_FIO_FileInit
#define FILE_IO_TERM        CTR_FIO_FileTerm
#define FILE_OPEN           CTR_FIO_FileOpen
#define FILE_CLOSE          CTR_FIO_FileClose
#define FILE_GETSIZE        CTR_FIO_GetFileSize

#define FILE_GETFILENAMES   CTR_FIO_GetFileNames

#define FILE_READ           CTR_FIO_FileRead
#define FILE_FGETS          CTR_FIO_FGets
#define FILE_SEEK           CTR_FIO_FSeek

/* o͌n */
#define PRINT_OUT           NN_LOG

/* n */


/* Ԍvn */
#ifdef ENABLE_TIMESCALE
typedef unsigned long       OS_TICK;
#endif /* #ifdef ENABLE_TIMESCALE */
#define OS_TICK_INIT        CTR_TickInit
#define OS_GET_TICK         CTR_GetTick
#define OS_TICKS_TO_MSEC(x) (x)

/*******************************************************************
  
*******************************************************************/


/* ̑ */



#endif /* #ifndef _CTR_DEFINE_H_ */
