// ----------------------------------------------------------------------
// Tv
//   JNX
// ----------------------------------------------------------------------
// Ql
//   C:\work\CTR\SampleDemos\camera\Simple.cpp/h
// ----------------------------------------------------------------------
#ifndef __CTRL_CAMERA__
#define __CTRL_CAMERA__

// ----------------------------------------------------------------------
// include system header
// ----------------------------------------------------------------------
#include	<nn/camera.h>

// ----------------------------------------------------------------------
// using namespace
// ----------------------------------------------------------------------
using namespace nn::camera;
using namespace nn::y2r;


#include	"TxtWinDebugTimer.h"
// ----------------------------------------------------------------------
// define
// ----------------------------------------------------------------------
// Y2R ̐ݒ
#define Y2R_INPUT_FORMAT        nn::y2r::INPUT_YUV422_BATCH
#define Y2R_OUTPUT_FORMAT       nn::y2r::OUTPUT_RGB_32
#define Y2R_BLOCK_ALIGNMENT     nn::y2r::BLOCK_LINE
#define Y2R_ROTATION            nn::y2r::ROTATION_NONE
#define YUV_BUFFER_NUM          (3)                  // ]pobt@̐(gvobt@)

// gp|[gƃJ
#define CAMERA_PORT             nn::camera::PORT_CAM1       // |[g1
#define SELECT_CAMERA           nn::camera::SELECT_IN1      // J

#define ALIGNMENT_SIZE          (64)
// ----------------------------------------------------------------------
// ݒ֐
// ----------------------------------------------------------------------
void	SetExporse				(int n);
void	SetAutoExporse			(int n);
void	SetSharpness			(int n);
void	SetPhotoMode			(int n);
void	SetWhiteBalance			(int n);
void	SetAutoWhiteBalance		(int n);
void	SetContrast				(int n);
void	SetLensCorrection		(int n);

// ----------------------------------------------------------------------
// enum擾֐
// ----------------------------------------------------------------------
void	GetPhotoModeStr			(int n, char* str);
void	GetWhiteBalanceStr		(int n, char* str);
void	GetContrastStr			(int n, char* str);
void	GetLensCorrectionStr	(int n, char* str);

// ----------------------------------------------------------------------
// class
// ----------------------------------------------------------------------
class CCtrlCamera
{
	// \z/j
public:
	CCtrlCamera();
	~CCtrlCamera();

	int			InitializeCamera	(CameraSelect select, Size size, FrameRate rate);
	void		FinalizeCamera		();

	void		Receive				(u8* rgbBuffer, CTxtWinDebugTimer& timer );

    void		CameraThreadFuncImpl();
protected:

private:

    // ----------------------------------------
    // JXbh֐
    void InitializeCameraThread(void);
    void FinalizeCameraThread(void);
//    void PrepareTransitionCallback(void);
//    void AfterTransitionCallback(void);

    // ----------------------------------------
    // J/Y2R֐
    void SetupCamera(void);
    nn::Result InitializeCameraSetting(void);
    void InitializeY2r(void);
    void InitializeResource(void);
    void FinalizeResource(void);
    void CameraRecvFunc(void);
    void CameraVsyncFunc(void);
    void StartCameraCapture(void);
    void StopCameraCapture(void);
    bool Y2rConversion(void);


	u32			m_width;
	u32			m_height;

    CameraSelect m_Select;
    Size         m_Size;
    FrameRate    m_FrameRate;
    NN_PADDING1;

    // -------------------------------------
    // J/ Y2R ]
    // -------------------------------------
    // YUV f[^̓]pobt@֘A
    s32 s_YuvTransferUnit;  // 1̓]TCY
    s32 s_YuvBufferSize;    // ]鍇vTCY(1 t[̃TCY)
    nn::y2r::StandardCoefficient s_Coefficient;    // J̏o̓f[^ɓK Y2R ̕ϊW
    NN_PADDING3;

    u8* s_pYuvBuffer[YUV_BUFFER_NUM];              // f[^̓]pobt@

    // obt@CfbNX
    s32 s_YuvBufferIndexCapturing;      // JLv`摜ǂݍރobt@
    s32 s_YuvBufferIndexLatestCaptured; // J̓ǂݍ݂ꂽobt@
    s32 s_YuvBufferIndexTransmitting;   // Y2R H֓]̃obt@

    nn::os::CriticalSection s_CsYuvSwap;    // Yuv obt@̔rp

    // RGB f[^̓]pobt@֘A
    s32 s_RgbBufferSize;            // ]鍇vTCY(1 t[̃TCY)
    u8* s_pRgbBuffer;               // f[^̓]pobt@

    // J̃CxgsXbh
    nn::os::Thread s_CameraThread;
    // CXbh̗Dx
    s32 s_MainThreadPriority;

    // -------------------------------------
    // Cxg
    // -------------------------------------
    // Jobt@ւ̃f[^]ʒm
    nn::os::Event s_CameraRecvEvent;

    // Jobt@֓]̃obt@G[ʒmACXbhJXbhNƂɂgp
    nn::os::Event s_CameraBufferErrorEvent;

    // JLv`ł̃J V uN荞ݒʒm
    nn::os::Event s_CameraVsyncEvent;

    // Y2R ł̕ϊA]̊ʒm
    nn::os::Event s_Y2rEndEvent;

    // JXbhҋ@Ԃɓ̂҂߂̃Cxg
    nn::os::LightEvent s_CameraThreadSleepAckEvent;

    // JXbh̑ҋ@Ԃ邽߂̃Cxg
    nn::os::LightEvent s_CameraThreadAwakeEvent;


    // -------------------------------------
    // tO
    // -------------------------------------
    // J̏Ă邩𔻕ʂtO
    bool s_IsCameraInitialized;

    // JXbhҋ@Ԃɂ邽߂̃tO
    bool s_IsCameraThreadSleep;

    // JXbhI邽߂̃tO
    bool s_IsCameraThreadEnd;

    // t[[gύX鎞̃tO
    bool s_SwitchFrameRateFlag;

    // Y2Rϊ҂̉摜邩ǂ̃tO
    bool s_ExistYuvImage;

    NN_PADDING3;


};

#endif	// __CTRL_CAMERA__
