// ----------------------------------------------------------------------
// Tv
//   `摀NX
// ----------------------------------------------------------------------
// Ql
//   C:\work\CTR\SampleDemos\demo1\graphics.cpp/h
// ----------------------------------------------------------------------
#ifndef __CTRL_GRAPHICS__
#define __CTRL_GRAPHICS__

// ----------------------------------------------------------------------
// include system header
// ----------------------------------------------------------------------
//#include	"../../../include/demo.h"
#include	"demo.h"

#include	<nn/gx.h>
#include	<nn/math.h>
#include	<nn/os.h>
#include	<nn/fnd.h>
#include	<nn/fs.h>
#include	<nn/y2r.h>

// ----------------------------------------------------------------------
// namespace
// ----------------------------------------------------------------------
using namespace nn::math;
using namespace nn::fnd;
using namespace demo;
using namespace nn::y2r;

// ----------------------------------------------------------------------
// class
// ----------------------------------------------------------------------
class CCtrlGraphics
{
public:
	CCtrlGraphics();
	~CCtrlGraphics();

	u32			InitializeGraphics	();
	void		FinalizeGraphics	();

	void		ClearDisplay	(const s32 display = NN_GX_DISPLAY_BOTH);
	void		SwapBuffer		(const s32 display = NN_GX_DISPLAY_BOTH);

	void		SetColor		(const s32 display, GLfloat r, GLfloat g, GLfloat b);
	void		DrawLine		(const s32 display, f32 sx, f32 sy, f32 ex, f32 ey);
	void		DrawRect		(const s32 display, f32 sx, f32 sy, f32 ex, f32 ey);
	void		DrawFull		(const s32 display, f32 sx, f32 sy, f32 ex, f32 ey);
	void		DrawCamera		(u8* textureDataPtr, u32 textureWidth, u32 textureHeight, u32 bmpWidth, u32 bmpHeight, u32 quality);
	void		DrawDateTime	(void);

	void		DrawTextEx		(const s32 display, u32 x, u32 y, char* fmt, ...);

	u8*			GetTextureDataFromBmpFileData(const u32& bmpWidth, const u32& bmpHeight, u8* bmpDataBuffer, 
					                          u32& textureWidth, u32& textureHeight, u32 quality);

	void		WaitVsync		(void);
protected:

private:
	void		InitTextureBuffer	(u32 textureWidth, u32 textureHeight);

	
	GLuint		m_PgID;			// program id
	GLuint		m_ShID;			// shader id
	uptr		m_HeapForGx;	// ExpHeap for app.

	demo::RenderSystemDrawing m_RenderSystemDrawing;

	GLuint		m_textureWidth;
	GLuint		m_textureHeight;
	u8*			m_textureGLDataBuffer;
	u8*			m_textureDataBuffer;
};

#endif	// __CTRL_GRAPHICS__
