// ----------------------------------------------------------------------
// eLXgWindowNX
// ----------------------------------------------------------------------

// ----------------------------------------------------------------------
// include system header
// ----------------------------------------------------------------------
#include	<nn.h>
#include	<nn/gx.h>
#include	<nn/math.h>
#include	<nn/os.h>
#include	<nn/fnd.h>
#include	<nn/fs.h>

#include	<string.h>

// ----------------------------------------------------------------------
// include
// ----------------------------------------------------------------------
#include	"CTR_Define.h"
#include	"CtrlGraphics.h"
#include	"TxtWindow.h"

// ----------------------------------------------------------------------
// define
// ----------------------------------------------------------------------
#define		TITLE_HEIGHT	10
#define		FONT_WIDTH		8
#define		FONT_HEIGHT		8

// ----------------------------------------------------------------------
// CTxtWindow::CTxtWindow
// ----------------------------------------------------------------------
// e
//   RXgN^
// ----------------------------------------------------------------------
// 
//   title		[ I ] WindowTitlew肵܂B
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
CTxtWindow::CTxtWindow(char* title)
{
	m_info = new STR_INFO[20];
	for (int n = 0 ; n < 20 ; n++)
	{
		LPSTR_INFO info = &m_info[n];
		info->str[0] = '\0';
		info->r		 = 0.0f;
		info->g		 = 0.0f;
		info->b		 = 0.0f;
	}
	sprintf(m_title, "%s", title);
	m_line		= 0;
	m_width		= 0;
	m_height	= 0;
	m_bForcus	= false;
}

// ----------------------------------------------------------------------
// CTxtWindow::~CTxtWindow
// ----------------------------------------------------------------------
// e
//   fXgN^
// ----------------------------------------------------------------------
// 
//   
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
CTxtWindow::~CTxtWindow()
{
	if (m_info != NULL)
	{
		delete [] m_info;
		m_info = NULL;
	}
}

// ----------------------------------------------------------------------
// CTxtWindow::SetLines
// ----------------------------------------------------------------------
// e
//   \̐w肵܂BiőQOsj
// ----------------------------------------------------------------------
// 
//   line		[ I ] ̐w肵܂B
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void CTxtWindow::SetLines(int line)
{
	if (line > 20) line = 20;
	m_line = line;
}

// ----------------------------------------------------------------------
// CTxtWindow::SetText
// ----------------------------------------------------------------------
// e
//   \镶w肵܂B
// ----------------------------------------------------------------------
// 
//   line		[ I ] ݒ肷sԍw肵܂B
//   str		[ I ] w肵܂B
//   r			[ I ] ԐF(0.0f ` 1.0f)w肵܂B
//   g			[ I ] ΐF(0.0f ` 1.0f)w肵܂B
//   b			[ I ] F(0.0f ` 1.0f)w肵܂B
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void CTxtWindow::SetText(int line, char* str, GLfloat r, GLfloat g, GLfloat b)
{
	LPSTR_INFO info = &m_info[line];
	sprintf(info->str, str);
	info->r = r;
	info->g = g;
	info->b = b;
}

// ----------------------------------------------------------------------
// CTxtWindow::DrawWindow
// ----------------------------------------------------------------------
// e
//   Window̕\s܂B
// ----------------------------------------------------------------------
// 
//   graphics		[ I ] `NXw肵܂B 
//   display		[ I ] `悷fBXvCw肵܂B
//   sx				[ I ] `JnXWw肵܂B
//   sy				[ I ] `IYWw肵܂B
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void CTxtWindow::DrawWindow(CCtrlGraphics* graphics, const s32 display, int sx, int sy)
{
	int width	= m_width;
	int height	= m_height;

	int text_width	= 0;
	int text_height = 0;

	// ----------------------------------------------------------------------
	// Ԓ񂩂畝
	// ----------------------------------------------------------------------
	int max_len = 0;
	int n = 0;
	for (n = 0 ; n < m_line ; n++)
	{
		LPSTR_INFO info = &m_info[n];
		max_len = (strlen(info->str) > max_len) ? strlen(info->str) : max_len;
	}
	text_width  = max_len * FONT_WIDTH + 2;

	// ----------------------------------------------------------------------
	// s獂
	// ----------------------------------------------------------------------
	text_height = TITLE_HEIGHT + m_line * FONT_HEIGHT + 2;

	width  = (m_width  > text_width ) ? m_width  : text_width;
	height = (m_height > text_height) ? m_height : text_height;

	// Z^O
	if (sx < 0)
	{
		sx = (320 - width) / 2;
	}

	if (sy < 0)
	{
		sy = (240 - height) / 2;
	}

	// ----------------------------------------------------------------------
	// ^Cg̔Zn / n`(tH[JXŐ؂ւ)
	// ----------------------------------------------------------------------
	int rect_sx = sx;
	int rect_ex = sx + width;
	int rect_sy = sy;
	int rect_ey = sy + height;

	if (m_bForcus == true)
	{
		graphics->SetColor(display, 0.0f, 0.0f, 0.5f);
		graphics->DrawFull(display, rect_sx, rect_sy, rect_ex, rect_ey);
	}
	else
	{
		graphics->SetColor(display, 0.5f, 0.7f, 1.0f);
		graphics->DrawFull(display, rect_sx, rect_sy, rect_ex, rect_ey);
	}

	// ----------------------------------------------------------------------
	// Window̃O[\
	// ----------------------------------------------------------------------
	rect_sx = sx + 1;
	rect_ex = sx + width - 1;
	rect_sy = sy + TITLE_HEIGHT;
	rect_ey = sy + height - 1;

	graphics->SetColor(display, 0.5f, 0.5f, 0.5f);
	graphics->DrawFull(display, rect_sx, rect_sy, rect_ex, rect_ey);

	// ----------------------------------------------------------------------
	// ^Cg`ij
	// ----------------------------------------------------------------------
	int txt_sx  = sx + 1;
	int txt_sy  = sy + 1;
	graphics->SetColor(display, 1.0f, 1.0f, 1.0f);
	graphics->DrawTextEx(display, txt_sx, txt_sy, m_title);

	// ----------------------------------------------------------------------
	// S` (eݒ肳ꂽF)
	// ----------------------------------------------------------------------
	txt_sx  = sx + 1;
	txt_sy  = txt_sy + TITLE_HEIGHT;
	for (n = 0 ; n < m_line ; n++)
	{
		LPSTR_INFO info = &m_info[n];
		graphics->SetColor(display, info->r, info->g, info->b);
		graphics->DrawTextEx(display, txt_sx + 1, txt_sy + FONT_HEIGHT * n, info->str);
	}
}

// ----------------------------------------------------------------------
// CTxtWindow::SetWindowWidth
// ----------------------------------------------------------------------
// e
//   Window̕w肵܂B
//   0w肵ꍇɂ͕\镶ɍ킹Ď܂B
// ----------------------------------------------------------------------
// 
//   width			[ I ] Window̕w肵܂B
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void CTxtWindow::SetWindowWidth(int width)
{
	m_width = width;
}

// ----------------------------------------------------------------------
// CTxtWindow::SetWindowHeight
// ----------------------------------------------------------------------
// e
//   Window̍w肵܂B
//   0w肵ꍇɂ͕\镶ɍ킹Ď܂B
// ----------------------------------------------------------------------
// 
//   height			[ I ] Window̍w肵܂B
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void CTxtWindow::SetWindowHeight(int height)
{
	m_height = height;
}

// ----------------------------------------------------------------------
// CTxtWindow::SetForcus
// ----------------------------------------------------------------------
// e
//   tH[JX̐ݒs܂B
// ----------------------------------------------------------------------
// 
//   bForcus		[ I ] tH[JX𓖂Ăꍇɂtruew肵܂B
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void CTxtWindow::SetForcus(bool bForcus)
{
	m_bForcus = bForcus;
}
