//**************************************************************************************
//
//		Motion Gesture Recognition Library (MGRLib)
//
//		MGRLib Native Source File
//
//		Copyright   :: (C) PANASNOIC CORPORATION, SYSTEM NETWORKS COMPANY 2010
//		Date        :: 2010.03.23
//		CPU         :: **
//		Language    :: C,C++
//		File Name   :: demo.cpp
//
//**************************************************************************************

// ----------------------------------------------------------------------
// define
// ----------------------------------------------------------------------
#define		CPLUSPLUS

// ----------------------------------------------------------------------
// include system header
// ----------------------------------------------------------------------
#include	<nn.h>
#include	<nn/os.h>
#include	<nn/fs.h>
#include	<nn/fnd.h>
#include	<nn/hid.h>
#include	<nn/math.h>
#include	<nn/hid.h>
#include	<nn/camera.h>
#include	<nn/y2r.h>
#include	<nn/hid.h>
#include	<nn/applet.h>

// ----------------------------------------------------------------------
// include mgr header
// ----------------------------------------------------------------------
#include	"mgr.h"					// mgrwb_[
using namespace mw::mgr;

// ----------------------------------------------------------------------
// include original header
// ----------------------------------------------------------------------
#include	"CTR_Define.h"
#include	"CtrlGraphics.h"
#include	"CtrlCamera.h"
#include	"TxtMenu.h"
#include	"TxtWindow.h"
#include	"TxtWinStartup.h"
#include	"TxtWinMenu.h"
#include	"TxtWinResultMgr.h"
#include	"TxtWinDebugTimer.h"
#include	"DebugWriterMgr.h"
#include	"appdefine.h"

// ----------------------------------------------------------------------
// using namespace
// ----------------------------------------------------------------------
using namespace nn::hid;
using namespace nn::os;
using namespace nn::math;

// ----------------------------------------------------------------------
// global
// ----------------------------------------------------------------------
extern nn::fnd::ExpHeap gAppHeap;
static u8 *rgbBuffer;

// ----------------------------------------------------------------------
// nnMain
// ----------------------------------------------------------------------
void nnMain(void)
{
	unsigned char	*extBuf			= NULL;
	u32				workSize        = 0;
	MGConfig		mgConfig;

	PSCimg			mgCimg;

	MGResult		mgResult;
	int				bodynum			= 0;
	MGObject		*object			= NULL;

	int 			n				= 0;
	int 			x				= 0;
	int 			y				= 0;
	int				i				= 0;
	int				ret				= 0;

	int				proc_width		= 320;				// Ŝ̕ 摜́`` iFj
	int				proc_height		= 240;				// Ŝ̍ 摜́`` iFj
	Size			proc_size		= SIZE_QVGA;
	FrameRate		proc_rate		= FRAME_RATE_30;
	int				proc_per		= 2;				// ͏摜 / F摜

	int				view_width		= nn::gx::CTR::DISPLAY1_HEIGHT;		// J摜\View̕   (DISPLAY1_HEIGHT = 320) 
	int				view_height		= nn::gx::CTR::DISPLAY1_WIDTH;		// J摜\View̍ (DISPLAY1_WIDTH = 240)

	int				mgr_width		= 160;				// F摜
	int				mgr_height		= 120;				// F摜

	int				txtWinSort		= 0;

	CCtrlGraphics	graphics;					// OtBbNNX
	CCtrlCamera		camera;						// JNX

	// Window class
	CTxtWinStartup			startWnd;			// NWindow
	CTxtWinMenu				menuWnd;			// j[Window
	CTxtWinResultMgr		resultWnd;			// Window
	CTxtWinDebugTimer		dbgTimerWnd(8);		// fobO^C}[\Window

	CDebugWriterMgr	dbgWriter;			// fobOo
	bool			dbg_init		= false;	

	char str[64];

	// ======================================================================

	PRINT_OUT("Demo Start\n");

    nn::Result result;

    // fs ̏
    nn::fs::Initialize();

    // hid ̏
    result = nn::hid::Initialize();
    NN_UTIL_PANIC_IF_FAILED(result);

    // z[j[sł悤 nn::applet::Enable() ̂݌Ă
    // z[j[Jڂd{^NbNAX[vɂ͔Ή
    nn::applet::Enable();
    
	// pbh
	PadReader		padReader;
	PadStatus		padStatus;

	OS_MEM_INIT();
	FILE_IO_INIT();
	OS_TICK_INIT();

 	// ----------------------------------------------------------------------
	// OtBbNNX̏
	// ----------------------------------------------------------------------
	graphics.InitializeGraphics();

 	// ----------------------------------------------------------------------
	// NWindow\AQQVGA/DS_LCD̂ݑΉ
	// ----------------------------------------------------------------------
	startWnd.DoModal(&graphics, NN_GX_DISPLAY1, -1, -1);
	
	eSTART_MODE eStartMode = startWnd.GetStartMode();

	if (eStartMode == eSTART_VGA)
	{
		proc_width		= 640;				// ͉摜/`摜
		proc_height		= 480;				// ͉摜/`摜
		proc_size		= SIZE_VGA;			// ̓TCY
		proc_rate		= FRAME_RATE_20;	// ̓t[[g
		mgr_width		= 160;				// F摜
		mgr_height		= 120;				// F摜
		proc_per		= 4;				// cꂼ1/4
	}
	else if (eStartMode == eSTART_QVGA)
	{
		proc_width		= 320;				// ͉摜/`摜
		proc_height		= 240;				// ͉摜/`摜
		proc_size		= SIZE_QVGA;		// ̓TCY
		proc_rate		= FRAME_RATE_30;	// ̓t[[g
		mgr_width		= 160;				// F摜
		mgr_height		= 120;				// F摜
		proc_per		= 2;				// cꂼ1/2
	}
	else if (eStartMode == eSTART_QQVGA)
	{
		proc_width		= 160;				// ͉摜/`摜
		proc_height		= 120;				// ͉摜/`摜
		proc_size		= SIZE_QQVGA;		// ̓TCY
		proc_rate		= FRAME_RATE_30;	// ̓t[[g
		mgr_width		= 160;				// F摜
		mgr_height		= 120;				// F摜
		proc_per		= 1;				// cꂼ1/1
	}
	else if (eStartMode == eSTART_DS_LCD)
	{
		proc_width		= 256;				// ͉摜/`摜
		proc_height		= 192;				// ͉摜/`摜
		proc_size		= SIZE_DS_LCD;		// ̓TCY
		proc_rate		= FRAME_RATE_30;	// ̓t[[g
		mgr_width		= 128;				// F摜
		mgr_height		= 96;				// F摜
		proc_per		= 2;				// cꂼ1/2
	}

 	// ----------------------------------------------------------------------
	// JNX̏
 	// ----------------------------------------------------------------------
	camera.InitializeCamera(SELECT_IN1, proc_size, proc_rate);

	dbgTimerWnd.SetTimerText(0, "recv camera    ");
	dbgTimerWnd.SetTimerText(1, "create cimg    ");
	dbgTimerWnd.SetTimerText(2, "proc exec      ");
	dbgTimerWnd.SetTimerText(3, "draw disp0     ");
	dbgTimerWnd.SetTimerText(4, "create texture ");
	dbgTimerWnd.SetTimerText(5, "draw disp1     ");
	dbgTimerWnd.SetTimerText(6, "other          ");
	dbgTimerWnd.SetTimerText(7, "swap buffer    ");

	// ----------------------------------------------------------------------
	// ݒ
	// ----------------------------------------------------------------------
	mgConfig.xsize		= mgr_width;				// 摜f[^		(128, 160)
	mgConfig.ysize		= mgr_height;				// 摜f[^		(96, 120)
	mgConfig.mgrect.sx	= 0;						// Ώۋ`̈
	mgConfig.mgrect.sy	= 0;						// Ώۋ`̈
	mgConfig.mgrect.ex	= mgr_width - 1;			// Ώۋ`̈
	mgConfig.mgrect.ey	= mgr_height - 1;			// Ώۋ`̈
	mgConfig.mgmode		= 0;						// F샂[h		(0, 1)
	mgConfig.frmparam	= 5;						// t[ԍx	(0 ` 10)
	mgConfig.spdparam	= 2;						// xx				(0 ` 4)
	mgConfig.sknparam	= 100;						// FtB^p[^(0 ` 200)		jVer 1.0.1 ǉ
	mgConfig.reserve0	= 0;						// \tO0
	mgConfig.reserve1	= 0;						// \tO1							jVer 1.0.1 ǉ
	mgConfig.reserve2	= 0;						// \tO2							jVer 1.0.1 ǉ
	mgConfig.reserve3	= 0;						// \tO3							jVer 1.0.1 ǉ

	// ----------------------------------------------------------------------
	// Cu֐FKvƗ̈TCY̎擾
	// ----------------------------------------------------------------------
	ret = MGRcgGetWorkSize(&mgConfig, &workSize);
	if (ret != PSERR_TRUE)
	{
		PRINT_OUT("MGRcgGetWorkSize NG\n");
		return;
	}
	PRINT_OUT("MGRcgGetWorkSize OK[%ld]\n", workSize);

	extBuf = (u8*)OS_MALLOC(workSize);
	if (extBuf == NULL)
	{
		PRINT_OUT("malloc extBuf NG\n");
		return;
	}

    rgbBuffer = (u8*)OS_MALLOC_EX( 640 * 480 * 4, 64 );

	mgCimg.xSize = mgr_width;
	mgCimg.ySize = mgr_height;
	mgCimg.pcImg = (RGBColor*)OS_MALLOC(mgr_width * mgr_height * sizeof(RGBColor));
	if (mgCimg.pcImg == NULL)
	{
		PRINT_OUT("malloc pcImg NG\n");
		OS_FREE(extBuf);
		return ;
	}

	// ----------------------------------------------------------------------
	// Cu֐F
	// ----------------------------------------------------------------------
	ret = MGRcgProcessInit(&mgConfig, extBuf);
	if (ret != PSERR_TRUE)
	{
		PRINT_OUT("MGRcgProcessInit NG\n");
		OS_FREE(extBuf);
		OS_FREE(mgCimg.pcImg);
		return;
	}
	PRINT_OUT("MGRcgProcessInit OK\n");

	// ----------------------------------------------------------------------
	// eWindow̐ݒ
	// ----------------------------------------------------------------------
	menuWnd.SetWindowWidth(nn::gx::DISPLAY0_HEIGHT);

	resultWnd.SetWindowWidth(306);
	resultWnd.SetWindowHeight(120);

	menuWnd.SetForcus(true);

	// ----------------------------------------------------------------------
	// C[v
	// ----------------------------------------------------------------------
	int frame	 = 0;
	while(1)
	{
		dbgTimerWnd.TimerAllStart();

		// ----------------------------------------------------------------------
		// J̃f[^擾
		// ----------------------------------------------------------------------
		camera.Receive(rgbBuffer,dbgTimerWnd);

		// ----------------------------------------------------------------------
		// PSCimg쐬 (オ(0, 0)ł邽ߏ㉺]) 
		// ----------------------------------------------------------------------
		dbgTimerWnd.TimerStart(1);
		if (menuWnd.IsEnableHandGesture() == true)
		{
			for (y = 0 ; y < proc_height ; y+=proc_per)
			{
				u32* dest = (u32*)((u8*)(mgCimg.pcImg) + (proc_height - 1 - y) / proc_per * mgr_width * 4);
				u32* src  = (u32*)(rgbBuffer + y * proc_width * 4);
				for (x = 0 ; x < proc_width ; x+=proc_per)
				{
					*dest++  = *src++;
					src		+= proc_per - 1;
				}
			}
		}
		dbgTimerWnd.TimerEnd(1);

		// ----------------------------------------------------------------------
		// F
		// ----------------------------------------------------------------------
		mgResult.bodynum	= 0;
		for (i = 0 ; i < MGRCG_BDYMAX ; i++)
		{
			mgResult.mgobject[i].id = 0;
			mgResult.mgobject[i].rect.sx = 0;
			mgResult.mgobject[i].rect.sy = 0;
			mgResult.mgobject[i].rect.ex = 0;
			mgResult.mgobject[i].rect.ey = 0;
			mgResult.mgobject[i].center.x = 0;
			mgResult.mgobject[i].center.y = 0;
		}
		mgResult.reserve0	= 0;
		mgResult.reserve1	= 0;
		mgResult.reserve2	= 0;
		mgResult.reserve3	= 0;

		mgConfig.mgmode		= menuWnd.GetMgMode();
		mgConfig.frmparam	= menuWnd.GetFrmparam();
		mgConfig.spdparam	= menuWnd.GetSpdparam();
		mgConfig.sknparam	= menuWnd.GetSknparam();	// Ver 1.0.1 ǉ
		
		dbgTimerWnd.TimerStart(2);
		if (menuWnd.IsEnableHandGesture() == true)
		{
			// ----------------------------------------------------------------------
			// Cu֐FF̎s
			// ----------------------------------------------------------------------
			ret = MGRcgProcessExec(&mgConfig, &mgCimg, &mgResult);
		}
		dbgTimerWnd.TimerEnd(2);

		bodynum		= mgResult.bodynum;
		object		= mgResult.mgobject;

		// ======================================================================
		// 
		// ======================================================================
		dbgTimerWnd.TimerStart(3);
		graphics.ClearDisplay(NN_GX_DISPLAY0);

		// ----------------------------------------------------------------------
		// Fʂݒ
		// ----------------------------------------------------------------------
		resultWnd.UpdateResult(&mgResult);

		// ----------------------------------------------------------------------
		// Window`
		// ----------------------------------------------------------------------
		for (n = txtWinSort ; n < txtWinSort + 3 ; n++)
		{
			switch((n + 1) % 3)
			{
			case 0: menuWnd.Draw	(&graphics, NN_GX_DISPLAY0,   0,  0);	break;
			case 1: resultWnd.Draw	(&graphics, NN_GX_DISPLAY0,  40, 80);	break;
			case 2:	dbgTimerWnd.Draw(&graphics, NN_GX_DISPLAY0,  10, 60);	break;
			}
		}

		// ----------------------------------------------------------------------
		// EɃt[`
		// ----------------------------------------------------------------------
		sprintf(str, "frame:[%08d]\n", frame++);
		graphics.SetColor(NN_GX_DISPLAY0, 0.0, 1.0, 0.0);
		graphics.DrawTextEx(NN_GX_DISPLAY0, 272, 214, str);

		// ----------------------------------------------------------------------
		// Swap
		// ----------------------------------------------------------------------
		graphics.SwapBuffer(NN_GX_DISPLAY0);

		dbgTimerWnd.TimerEnd(3);

		// ======================================================================
		// fBXvC
		// ======================================================================

		// ----------------------------------------------------------------------
		// `eNX`[̐
		// ----------------------------------------------------------------------
		u32 bmpWidth		= proc_width;
		u32 bmpHeight		= proc_height;
		u32 textureWidth	= 0;
		u32 textureHeight	= 0;

		dbgTimerWnd.TimerStart(4);
		int quality = menuWnd.GetDrawQuality();
		u8* texBuffer = graphics.GetTextureDataFromBmpFileData(bmpWidth, bmpHeight, rgbBuffer, textureWidth, textureHeight, quality);
		dbgTimerWnd.TimerEnd(4);

		// ----------------------------------------------------------------------
		// `
		// ----------------------------------------------------------------------
		dbgTimerWnd.TimerStart(5);
		graphics.ClearDisplay(NN_GX_DISPLAY1);
		graphics.DrawCamera(texBuffer, textureWidth, textureHeight, bmpWidth, bmpHeight, quality);
		graphics.DrawDateTime();
		dbgTimerWnd.TimerEnd(5);

		// ----------------------------------------------------------------------
		// Fʂ̕`
		// ----------------------------------------------------------------------
		// FӏԘgň͂
		// ----------------------------------------------------------------------
		dbgTimerWnd.TimerStart(6);
		object	= mgResult.mgobject;
		for (n = 0 ; n < bodynum ; n++ )
		{
			// Jn_
			float sx	= (float)object->rect.sx * ((float)view_width  / (float)mgr_width);
			float sy	= (float)object->rect.sy * ((float)view_height / (float)mgr_height);

			// I_
			float ex	= (float)object->rect.ex * ((float)view_width  / (float)mgr_width);
			float ey	= (float)object->rect.ey * ((float)view_height / (float)mgr_height);

			graphics.SetColor(NN_GX_DISPLAY1, 1.0, 0.0, 0.0);
			graphics.DrawLine(NN_GX_DISPLAY1, sx, sy, ex, sy);
			graphics.DrawLine(NN_GX_DISPLAY1, ex, sy, ex, ey);
			graphics.DrawLine(NN_GX_DISPLAY1, ex, ey, sx, ey);
			graphics.DrawLine(NN_GX_DISPLAY1, sx, ey, sx, sy);
			object++;
		}

		// ----------------------------------------------------------------------
		// Rg[[̑ɂ郁j[̑
		// ----------------------------------------------------------------------
		// LR{^WindowI
		// ㉺{^ōڂ̑
		// AB{^Œl̕ύX
		// X{^SDo
		// Y{^ŏI
		// ----------------------------------------------------------------------
		padReader.ReadLatest(&padStatus);

		if (txtWinSort == 0)
		{
			menuWnd.Ctrl(&padStatus);
		}

		// L Button i}CiXj
		if (padStatus.trigger & BUTTON_L)
		{
			txtWinSort -= (txtWinSort > 0) ? 1 : -2;
		}

		// R Button ivXj
		if (padStatus.trigger & BUTTON_R)
		{
			txtWinSort += (txtWinSort < 2) ? 1 : -2;
		}

		// tH[JX̐؂ւ
		menuWnd.SetForcus(		txtWinSort == 0);
		resultWnd.SetForcus(	txtWinSort == 1);
		dbgTimerWnd.SetForcus(	txtWinSort == 2);

		// X Button SDɏo
		if (padStatus.trigger & BUTTON_X)
		{
			if (dbg_init == false)
			{
				dbg_init = dbgWriter.Initialize();
			}

			// ɐĂꍇ̂ݏo
			if (dbg_init == true)
			{
				dbgWriter.Output(rgbBuffer, proc_width, proc_height, &mgResult);
			}
		}

		// Y Button ŏI
		if (padStatus.trigger & BUTTON_Y)
		{
			break;
		}

		dbgTimerWnd.TimerEnd(6);

		// ----------------------------------------------------------------------
		// Swap
		// ----------------------------------------------------------------------
		dbgTimerWnd.TimerStart(7);
		graphics.SwapBuffer(NN_GX_DISPLAY1);
		dbgTimerWnd.TimerEnd(7);

		// ----------------------------------------------------------------------
		// wait vsync
		// ----------------------------------------------------------------------
		graphics.WaitVsync();
		dbgTimerWnd.TimerAllEnd();
	}

	///////////////////////////
	///////////////////////////
	///////////////////////////
	// Free all memory areas.
	///////////////////////////
	///////////////////////////
	///////////////////////////
    OS_FREE( rgbBuffer );

	if (extBuf != NULL)
	{
		OS_FREE(extBuf);
		extBuf = NULL;
	}

	if (mgCimg.pcImg != NULL)
	{
		OS_FREE(mgCimg.pcImg);
		mgCimg.pcImg = NULL;
	}

	graphics.FinalizeGraphics();
	camera.FinalizeCamera();

	// hid ̔j
	nn::hid::Finalize();

	FILE_IO_TERM();
	OS_MEM_TERM();

	//////////////////
	//////////////////
	//////////////////
	// Return .
	//////////////////
	//////////////////
	//////////////////
	PRINT_OUT("Program END\n");

	return ;
}

//	End of File ////////////////////////////////////////////////////////////////////////
